const nsIThread = Components.interfaces.nsIThread;
const nsIEventQueueService = Components.interfaces.nsIEventQueueService;
var accountManager = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager);
var messenger = Components.classes[messengerContractID].createInstance().QueryInterface(Components.interfaces.nsIMessenger);
var mailSession = Components.classes[mailSessionContractID].getService(Components.interfaces.nsIMsgMailSession);

var notifyFlags = Components.interfaces.nsIFolderListener.all;

var tree = GetThreadTree();

var copyservice = Components.classes["@mozilla.org/messenger/messagecopyservice;1"].getService(Components.interfaces.nsIMsgCopyService);
var proxyObjectManager = Components.classes["@mozilla.org/xpcomproxy;1"]
                                 .getService(Components.interfaces.nsIProxyObjectManager);
var eqService = Components.classes["@mozilla.org/event-queue-service;1"]
       	       	                .getService(nsIEventQueueService);
var uiQ = eqService.getSpecialEventQueue(nsIEventQueueService.UI_THREAD_EVENT_QUEUE);

var controller=new MailClassifierController(accountManager.allServers);

var proxySync= proxyObjectManager.INVOKE_SYNC | proxyObjectManager.FORCE_PROXY_CREATION;

var proxyAsync= proxyObjectManager.INVOKE_ASYNC | proxyObjectManager.FORCE_PROXY_CREATION;


function getProxyFor(obj,interf,type){
	return proxyObjectManager.getProxyForObject(uiQ,interf,
                               obj,
                               type);
}

function getSyncProxy(obj,interf){
	return getProxyFor(obj,interf,proxySync);
}

function getAsyncProxy(obj,interf){
	return getProxyFor(obj,interf,proxyAsync);
}

function createProxy(cid,interf,type){
	return proxyObjectManager.getProxy(uiQ,cid,null,interf,
                               type);
}

function createThread(){
	return Components.classes["@mozilla.org/thread;1"].createInstance(nsIThread); 
}
function ClassifyTask(uri,account){
	this.uri=uri;
	this.account=account;
	this.run=function(){
		controller.classifyMessage(this.uri,this.account);
	}
}
function classifyMessageOnThread(uri,account){
	var thread=createThread();
	thread.init(new ClassifyTask(uri,account) ,0,
                    nsIThread.PRIORITY_NORMAL,
                    nsIThread.SCOPE_GLOBAL,
                    nsIThread.STATE_UNJOINABLE);
}

function isUserFolder(folder){
	//var specialFolder = GetFolderAttribute(folderTree, 1);
	var isInbox = IsSpecialFolder(folder, MSG_FOLDER_FLAG_INBOX, false);
	var isBozze = IsSpecialFolder(folder, MSG_FOLDER_FLAG_DRAFTS, false);
	var isModelli = IsSpecialFolder(folder, MSG_FOLDER_FLAG_TEMPLATES, false);
	var isSent = IsSpecialFolder(folder, MSG_FOLDER_FLAG_SENTMAIL, false);
	var isTrash = IsSpecialFolder(folder, MSG_FOLDER_FLAG_TRASH, false);
	var isJunk = IsSpecialFolder(folder, MSG_FOLDER_FLAG_JUNK, false);
	var isQueue = IsSpecialFolder(folder, MSG_FOLDER_FLAG_QUEUE, false);
	
	var ret = !(isInbox || isBozze || isModelli || isSent || isTrash ||
		 isJunk || isQueue);
	
	/*debug(ret);
	var pop1= MSG_FOLDER_FLAG_MAIL;
	var pop2= pop1 | MSG_FOLDER_FLAG_ELIDED;
	var imap1= MSG_FOLDER_FLAG_IMAP_PERSONAL | MSG_FOLDER_FLAG_IMAPBOX |
		   MSG_FOLDER_FLAG_MAIL;
	var imap2= imap1 | MSG_FOLDER_FLAG_ELIDED;

	if (folder.server.type=="pop3"){
		return (folder.flags == pop1 || folder.flags == pop2);
	}
	else if(folder.server.type=="imap"){
		return (folder.flags == imap1 || folder.flags == imap2) && folder.name!="Junk";
	}*/
	return ret;
}

var mailClassifierListener= {
     OnItemAdded: function(parentItem, item) {
		parentItem=parentItem.QueryInterface(Components.interfaces.nsIMsgFolder);
		if(parentItem.getFlag(MSG_FOLDER_FLAG_INBOX)){
			try{
				mail=item.QueryInterface(Components.interfaces.nsIMsgDBHdr);
				uri=parentItem.getUriForMsg(mail);
				//classifyMessageOnThread(uri,parentItem.server);
				controller.classifyMessage(uri,parentItem.server);
			}
			catch(e){}
		}
		else{
			try{
				var tuttiUsr=true;
				parentItem.QueryInterface(Components.interfaces.nsIMsgFolder);
				var par=parentItem;
				while(par!=parentItem.rootFolder){
					if(!isUserFolder(par)){
						tuttiUsr=false;
					}
					par=par.parentMsgFolder;
				}
				if(tuttiUsr){
					var fol1=item.QueryInterface(Components.interfaces.nsIMsgFolder);
					if(isUserFolder(fol1)){
						controller.addFolder(fol1);
					}
				}
			}
			catch(e){}
		}
	},
     OnItemRemoved: function(parentItem, item){
		parentItem=parentItem.QueryInterface(Components.interfaces.nsIMsgFolder);
		if(parentItem.getFlag(MSG_FOLDER_FLAG_INBOX)){
			mail=item.QueryInterface(Components.interfaces.nsIMsgDBHdr);
			uri=parentItem.getUriForMsg(mail);
			controller.unclassifyMessage(uri,parentItem.server);
		}
		else{
			try{
				var fol1=item.QueryInterface(Components.interfaces.nsIMsgFolder);
				controller.removeFolder(fol1);
			}
			catch(e){}
     		}
      },
     OnItemPropertyChanged: function(item, property, oldValue, newValue) {
     },
 
     OnItemIntPropertyChanged: function(item, property, oldValue, newValue) {
     },
 
     OnItemBoolPropertyChanged: function(item, property, oldValue, newValue) {
     },
 
     OnItemUnicharPropertyChanged: function(item, property, oldValue, newValue){
     },
     OnItemPropertyFlagChanged: function(item, property, oldFlag, newFlag) {
      },
 
     OnItemEvent: function(folder, event) {
     },
     observe: function(subject,topic,data){
		if(topic=="quit-application"){
			//dump(controller);
			//controller.shutdown();
		}
		/*else if(topic=="reroot"){
			onChangeSelection(subject);
		}*/
     }
}
/*function classifyMsgsForFolder(folder){
        var Msgs = folder.getMessages(msgWindow);
	while (Msgs.hasMoreElements( )){
               msg = Msgs.getNext().QueryInterface(Components.interfaces.nsIMsgDBHdr);
		var uri=folder.getUriForMsg(msg);
		var msg1=controller.getFirstMessageClassification(uri);
		dump(uri+"\n");
		dump(msg1+"\n");
	}
}
function initialClassifications() {
	alls=accountManager.allServers;
	for(i=0;i<alls.Count();i++){
		server=alls.GetElementAt(i);
		if(server.type=="pop3" || server.type=="imap"){
			msgFolder=server.rootFolder;
			var outNumFolders = new Object();
			var inboxFolder = msgFolder.getFoldersWithFlag(MSG_FOLDER_FLAG_INBOX, 1, outNumFolders);
			//inboxFolder.AddFolderListener(mailClassifierFolderListener, notifyFlags);
			classifyMsgsForFolder(inboxFolder);
		}		
	}
}*/
function getUserFolders(){
	var folderselres= GetSelectedFolderResource();
        var foldersel =  GetMsgFolderFromResource(folderselres);
	var account=foldersel.server;
	var ufolders=controller.getUFolders(account);
	/*var folders = root.GetSubFolders();
	var done=false;
	while(!done){
		var folder = folders.currentItem().QueryInterface(Components.interfaces.nsIMsgFolder);
		res=(folder.flags == MSG_FOLDER_USER_CREATED)
		if(res){ 
			ret.push(new FolderView(folder.name,folder));
		}
	       	try {
        		folders.next();
        	} 
         	catch (ex){
         		done = true;
         	}        			
	}*/
	return ufolders;
}
function getClassifiedFolders(classifications){
	ret=new Array();
	if(classifications!=null){
		for(i=0;i<classifications.length;i++){
			fol=classifications[i];
			fv=new FolderView((i+1)+") "+fol.mozillaFolder.name,fol);
			ret.push(fv);
		}
	}
	return ret;
}
function map(fun,arr,i){
	if(i==arr.length) return new Array();
	else{
		b=fun(arr[i]);
		rtr=map(fun,arr,i+1)
		rtr.push(b);
		return rtr;
	}
}
insertedFoldersOrdered=new Array();
function change(folders){
	ret=new Array();
	for(i=0;i<folders.length;i++){
		fol=folders[i];
		item=document.createElement("menuitem");
		item.setAttribute("id",i);
		item.setAttribute("label",fol.name);
		item.setAttribute("class","menuitem-iconic");
		item.setAttribute("oncommand","changeFolder(expfolders["+i+"]);");
		ret.push(item);
	}
	return ret;
}
function subtract(x,y){
	ret=new Array();
	for(i=0;i<x.length;i++){
		presente=false;
		for(j=0;j<y.length;j++){
			if(x[i].folder==y[j].folder) presente=true;
		}
		if(!presente) ret.push(x[i]);
	}
	return ret;	
}
function createSeparator(){
	return document.createElement("menuseparator");
}
function getTreeViews(ufolders,i){
	var a=new Array();
	for(u in ufolders){
		var ufolder=ufolders[u];
		if(ufolder.children && ufolder.parent==null) a.push(ufolder);
	}
	return getTreeViews1(a,i)[0];
}
function getTreeViews1(ufolders,i){
	var ret=new Array();
	for(u in ufolders){
		var ufolder=ufolders[u];
		if(ufolder.children){
			insertedFoldersOrdered.push(ufolder.mozillaFolder);
			if((ufolder.children.size()-1)==0){
				var item=document.createElement("menuitem");
				item.setAttribute("label",ufolder.mozillaFolder.name);
				item.setAttribute("tooltiptext",ufolder.fullPath);
				item.setAttribute("class","menuitem-iconic");
				item.setAttribute("oncommand","changeFolder(insertedFoldersOrdered["+i+"]);");
			}
			else{
				var item=document.createElement("menu");
				item.setAttribute("label",ufolder.mozillaFolder.name);
				item.setAttribute("tooltiptext",ufolder.fullPath);
				item.setAttribute("class","menu-iconic");
				//item.setAttribute("class","menuitem-iconic");
				//item.setAttribute("oncommand","changeFolder(insertedFoldersOrdered["+i+"]);");
				var popup=document.createElement("menupopup");
				
				var questoLabel = extbundle.GetStringFromName("this_menuitem_label");
				var questo=document.createElement("menuitem");
				questo.setAttribute("label",questoLabel);
				questo.setAttribute("tooltiptext",questoLabel);
				questo.setAttribute("oncommand","changeFolder(insertedFoldersOrdered["+i+"]);");
				item.appendChild(popup);
				popup.appendChild(questo);
				popup.appendChild(createSeparator());
				var ret1=getTreeViews1(ufolder.children,i+1);
				for(u1 in ret1[0]){popup.appendChild(ret1[0][u1]);}
				i=ret1[1]-1;
			}
			ret.push(item);
			i++
		}
	}
	return [ret,i];
}
function insertUserFolders(root,move,classifications){
	insertedFoldersOrdered=new Array();
	ufolders=getUserFolders();
	set=getClassifiedFolders(classifications);
	ret=0;
	insert=function(fols){
		return function(node){
			fols.appendChild(node);
		}
	}
	if(set.length>0){ret++;move.removeAttribute("disabled");}
	set.shift();
	views=new Array();
	for(var i=0;i<set.length;i++){
		var fol=set[i];
		var item=document.createElement("menuitem");
		item.setAttribute("label",fol.nome);
		item.setAttribute("tooltiptext",fol.folder.fullPath);
		item.setAttribute("class","menuitem-iconic");
		item.setAttribute("oncommand","changeFolder(insertedFoldersOrdered["+i+"]);");
		views.push(item);
		insertedFoldersOrdered.push(fol.folder.mozillaFolder);
	}
	if(views.length>0) views.push(createSeparator());
	var ufolderViews=getTreeViews(ufolders,i);
	views=views.concat(ufolderViews);
	if(views.length>0){ret++; root.parentNode.removeAttribute("disabled");}
	map(insert(root),views,0);
	return ret;
}
function getCurrentFolder(){
        var foldersel = GetSelectedFolderResource();
        return GetMsgFolderFromResource(foldersel);
}
function removeAllChildren(node){
	while(node.childNodes.length>0){
		node.removeChild(node.childNodes[0])
	}
}
function updateFolders(uri){
	var menu=document.getElementById('threadPaneContext-classify');
	var folders=document.getElementById('threadPaneContext-MCchange');
	var move=document.getElementById('threadPaneContext-MCmove');
	removeAllChildren(folders.childNodes[0]);
	menu.setAttribute("disabled","true");
	folders.setAttribute("disabled","true");
	move.setAttribute("disabled","true");
	if(uri){
		var classifications=controller.getClassifications(uri);
		ret=insertUserFolders(folders.childNodes[0],move,classifications);
		if(ret!=0) menu.removeAttribute("disabled");
	}
}
function setClassificationsOnMoveTo(folder){
	var indices=GetSelectedIndices(GetDBView());
	for(var i=0;i<indices.length;i++){
		var uri=GetURIForIndex(indices[i]);
		controller.setClassification(uri,folder);
	}
}
function changeFolder(fold){
	setClassificationsOnMoveTo(fold);
	gDBView.doCommandWithFolder(nsMsgViewCommandType.moveMessages, fold);
	//tree.view.selection.clearSelection();
}
function GetURIForIndex(index){
	return tree.view.QueryInterface(Components.interfaces.nsIMsgDBView).getURIForViewIndex(index);
}
function refreshClassifications(){
	tree.treeBoxObject.invalidate();
}
function clickOnTreeCell(event)

{
  var row = {}, col = {}, obj = {};
  tree.treeBoxObject.getCellAt(event.clientX, event.clientY,row,col,obj);
  var uri=null;
  if(row.value>=0) uri=GetURIForIndex(row.value);
  updateFolders(uri);
  if (event && event.type == "click" && event.button==0)
  {
    if (obj.value=="text" && (col.value==mailclassifierColId || col.value.id==mailclassifierColId) && uri){
		var fol=controller.getFirstMessageClassification(uri);
		if(fol) changeFolder(fol);
    }
  }

}
function moveSelectedMessages(source,indicesArray){
	var folsrc=source.QueryInterface(Components.interfaces.nsIRDFResource);
	var objs=new Array();
	for(i in indicesArray){
		var uri=GetURIForIndex(indicesArray[i]);
		var foldst=controller.getFirstMessageClassification(uri);
		if(foldst && uri){
			obj=new Object();
			obj.msg=messenger.messageServiceFromURI(uri).messageURIToMsgHdr(uri);
			obj.foldst=foldst.QueryInterface(Components.interfaces.nsIRDFResource);
			objs.push(obj);
		}
	}
	objs.sort(function(x,y){
		if(x.foldst.name<y.foldst.name) return -1;
		else if(x.foldst.name==y.foldst.name) return 0;
		return 1;	
	});
	var list = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);
	var i=0;
	while(i<objs.length){
		var fol=objs[i].foldst;
		list = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);
		while(i<objs.length && objs[i].foldst==fol){
			msg=objs[i].msg;
			foldst=objs[i].foldst;
			controller.setClassification(msg.folder.getUriForMsg(msg),foldst);
			list.AppendElement(msg);
			i++;
		}
		copyservice.CopyMessages(folsrc, list, fol , true , null , msgWindow , true );
	}
}
function fromTo(n,m){
	ret=new Array();
	for(var i=n;i<=m;i++){
		ret.push(i);
	}
	return ret;
}
function onMoveSelectedMessages(){
	indices=GetSelectedIndices(GetDBView());
	moveSelectedMessages(getCurrentFolder(),indices);
}
function onMoveSelectedMessagesButton(){
	if(tree.view.rowCount<=0) return;
	debug(tree.view.getCellText);
	if(tree.view.selection.count==0){
		 moveSelectedMessages(getCurrentFolder(),fromTo(0,tree.view.rowCount));
	}
	onMoveSelectedMessages();
}
function onChangeSelection(){
	var menuitem_sposta=document.getElementById('MCMenu_sposta');
	var count=tree.view.rowCount;
	menuitem_sposta.setAttribute("disabled","true");
	if(count && count>0){
		menuitem_sposta.removeAttribute("disabled");	
	}
}
function addColumn(){
	var column=document.createElement("treecol");
	tree.childNodes[0].appendChild(column);     
	var label = extbundle.GetStringFromName("MCColumnName");
	var tooltip=extbundle.GetStringFromName("MCColumnTooltip");
	column.setAttribute('id', "mailclassifierCol" );
	column.setAttribute("label",label);
	column.setAttribute("tooltiptext",tooltip);
	//column.setAttribute("class","sortDirectionIndicator");
	//column.setAttribute("sort","?mailclassifierCol");
	column.setAttribute("persist","hidden swappedhidden ordinal width sortActive sortDirection");
	tree.addEventListener('click', clickOnTreeCell, true);
}
function classifyCurrentMail(){
	var curr=getCurrentFolder();
	if(curr.getFlag(MSG_FOLDER_FLAG_INBOX)){
		for(var i=0;i<tree.view.rowCount;i++){
			var uri=GetURIForIndex(i);
			controller.forceClassify(uri,curr.server);	
		}
	}
}
function mailClassifierInit(){
	addColumn();
	//initialClassifications();
	mailSession.AddFolderListener(mailClassifierListener, notifyFlags);
	//observerService.addObserver(mailClassifierListener,"reroot",false);
	//accountManager.addRootFolderListener(mailClassifierFolderListener);
}
window.addEventListener("load", mailClassifierInit, false);

